// SharpAt.cpp
// #@C^v^p̊bvO
#include	"SharpAt.h"

//=======================================
// Q[p
//=======================================
extern char *str_sharpat_help;	// Jn̐p

//=======================================
// CLASS DATA
//=======================================
char CSharpAt::str_buf[SAT_STR_MAX + 16];	// 擾p̃obt@F{Ŏgp
char CSharpAt::str_buf2[SAT_STR_MAX + 16];	// 擾p̃obt@2FɊgŎgp

//=======================================
// DATA
//=======================================
// R}hCꍇ͂̃t@Cs
char sat_def_fname[]="SharpAt.txt";

//=======================================
// #@NXF{
//=======================================
// RXgN^
CSharpAt::CSharpAt()
{
	src = _src; Free();
	// g֐ݒ
	for(int i=0; i<26; i++)
	{
		p_ExProc[i] = ExPr_D;
	}
	SetExPr('C', ExPr_Calc);	// CFvZp
	SetExPr('D', ExPr_DMes);		// DFfobOp̊g֐
	SetExPr('G', ExPr_Grp);		// GF摜`
	SetExPr('K', ExPr_Key);		// KFL[擾
	SetExPr('S', ExPr_Sound);	// SFTEhp
}
// Sĉ
void CSharpAt::Free()
{
	// INIT
	pos = at = st_pos = 0;
	fsize = 0;
	err = 0;
	memset(src, 0, sizeof(src));
	memset(mem, 0, sizeof(mem));
	memset(stack, 0, sizeof(stack));
	memset(proc, 0, sizeof(proc));
}

#ifdef _DXLIB
// fBNgP߂i'\\'̌NULLɂj
//RET:߂̒̕
int GetBackDir(char *dir)
{
	int i;
	for(i=strlen(dir)-1; i>=1; i--)
	{
		// O͑Sp̌H
		if(_mbsbtype((BYTE*)dir,i) == 2)
			i --;
		// Zp[^H
		if((dir[i-1]=='\\') || (dir[i-1]=='/'))
			break;
	}
	dir[i] = 0;
	return i;
}
#endif

// \[Xt@Cǂݍ
//RET: -1=ERR
int CSharpAt::LoadSrcFile(char *fName)
{
#ifdef _DXLIB
	int sf = FileRead_open(fName);
	if( sf==0 )
	{
		MES_PUT("Error: Not file [ %s ]",fName);
		return -1;
	}
	// TCYI[o[H
	LONGLONG size = FileRead_size(fName);
	if(size > SAT_SRC_SIZE_MAX)
	{
		MES_PUT("Error: File size (%d / %d)",size,SAT_SRC_SIZE_MAX);
		return -1;
	}
	// ǂݍ
	ERET( FileRead_read(src, (int)size, sf) );
	fsize = (int)size;
	// RgsATabXy[XŖ߂F\[XǂݍݎɎs֐
	SetCommentSpcAll();
	// Xy[XSċl߂FAAg֐ɓnp̓̕`FbNȂ
	CtSpaceCutSrcAll();
	// tH_ƃt@C𒊏o
	char dir[2000],fn[256];
	strcpy(dir,fName);
	int n = GetBackDir(dir);
	strcpy(fn,fName+n);
	// ۑ
	sprintf(dir+strlen(dir),"tmp_%s.txt",fn);
	{
		// t@C쐬
	//	ERET(sf.Open(dir,FNEW));
		void *m_fh = CreateFile(dir,GENERIC_WRITE,0,NULL,TRUNCATE_EXISTING,FILE_ATTRIBUTE_ARCHIVE,NULL);
		if(m_fh == INVALID_HANDLE_VALUE)
			m_fh = CreateFile(dir,GENERIC_WRITE,0,NULL,CREATE_NEW,FILE_ATTRIBUTE_ARCHIVE,NULL);
		if(m_fh == INVALID_HANDLE_VALUE)	//ERR
			return -1;
	//	sf.Write(src,fsize);
		DWORD	siz;
		WriteFile(m_fh,src,fsize,&siz,NULL);
		CloseHandle(m_fh);
	}
#else
	// t@CJ
	CStdFile sf;
	if( sf.Open(fName, LOAD)==-1 )
	{
		MES_PUT("Error: Not file [ %s ]", fName);
		return -1;
	}
	// TCYI[o[H
	int size = sf.GetSize();
	if (size > SAT_SRC_SIZE_MAX)
	{
		MES_PUT("Error: File size (%d / %d)", size, SAT_SRC_SIZE_MAX);
		return -1;
	}
	// ǂݍ
	ERET( sf.Read(src,size) );
	fsize = size;
	// RgsATabXy[XŖ߂F\[XǂݍݎɎs֐
	SetCommentSpcAll();
	// Xy[XSċl߂FAAg֐ɓnp̓̕`FbNȂ
	CtSpaceCutSrcAll();
	// tH_ƃt@C𒊏o
	char dir[2000], fn[256];
	strcpy(dir,fName);
	int n = GetBackDir(dir);
	strcpy(fn, fName+n);
	// ۑ
	sprintf(dir+strlen(dir),"tmp_%s.txt",fn);
	ERET( sf.Open(dir,FNEW) );
	sf.Write(src,fsize);
#endif
	return 0;
}

// w̒lX^bN
void CSharpAt::CtPush(int n)
{
	// ȏ̓X^bNłȂH
	if( st_pos >= SAT_STACK_MAX )
	{
		MES_PUT("Error: Stack over");
		ERR_PUT(pos-1);
		return;
	}
	stack[st_pos++] = n;
}

// X^bNo
int CSharpAt::CtPop()
{
	if(st_pos<=0)
	{
		MES_PUT("Error: Stack zero");
		ERR_PUT(pos - 1);
		return 0;
	}
	st_pos --;
	return stack[st_pos];	// |bv̒l̓NAȂ悤
}

// RgsATabXy[XŖ߂F\[XǂݍݎɎs֐
void CSharpAt::SetCommentSpcAll()
{
	pos = 0;
	while (pos < fsize)
	{
		switch (src[pos])
		{
		case ' ': pos++; break;	// Space
		case 0x9: src[pos++] = ' '; break;	// TAB
		case 0x0D: src[pos++] = ' '; 	// s
		case 0x0A: src[pos++] = ' ';  break;	// s
		case '/':
			if (src[pos + 1] == '/')	// ȍ~RgsH
			{
				src[pos++] = ' '; src[pos++] = ' ';
				// s܂ŃpX
				while (1)
				{
					if (pos >= fsize) goto _END;	// I
					// SpH
					if( IsZenkaku(src[pos]) )
					{
						src[pos++] = ' '; src[pos++] = ' ';
						continue;
					}
					// s`FbN
					switch (src[pos])
					{
					case 0x0D: src[pos++] = ' ';
						if(src[pos] != 0x0A )
							goto _JMP;	// s
					case 0x0A: src[pos++] = ' ';
						goto _JMP;	// s
					}
					// p
					src[pos++] = ' ';
				}
_JMP:
				break;
			}
		default:
			pos ++;
			break;
		}
	}
_END:
	pos = 0;	// INIT
}

// Xy[XSċl߂FAAg֐ɓnp̓̕`FbNȂ
//Rgs𖳂ԂŎs邱
void CSharpAt::CtSpaceCutSrcAll()
{
	pos = 0;
	while (pos < fsize)
	{
		// g֐H
		char c = src[pos];
		if ((c >= 'A') && (c <= 'Z'))
		{
			// ;܂Ŕ΂
			if( CtSrcPass(';')==0 )
				break;
			c = src[pos];
		}
		// Xy[XH
		if( c==' ' )
		{
			int bk = pos;
			// Xy[X̏I܂Ői
			if( CtNextSrc()==0 )
			{
				fsize -= pos - bk;
				break;
			}
			// Xy[Xl߂
			memcpy(&src[bk], &src[pos], fsize - pos);
			fsize -= pos-bk;	// TCY炷
			pos = bk;	// ߂
			continue;
		}
		// NEXT
		pos ++;
	}
	src[pos] = 0;
	pos = 0;	// INIT
}

//---------------------------------------
// ֌WȂpX
//RET: 0=I
int CSharpAt::CtNextSrc()
{
	while (pos < fsize)
	{
		switch(src[pos])
		{
		case ' ': pos++; break;	// Space
		case ';': pos++; break;	// ;
		default:
			return 1;	// NEXT
		}
	}
	return 0;	// I
}

// w̕܂Ŏ܂ŃpX
//RET: 0=I
int CSharpAt::CtSrcPass(char c)
{
	while (pos < fsize)
	{
		if(src[pos++]==c)
			return 1;	// NEXT
	}
	return 0;	// I
}

// w1̕܂Ŏ܂ŃpXBAAw2̕ꍇ́Aw1̌o𑝂₷
//Ⴆ΁A[EE[EE]EE]ŁAΉ]܂Ői݂p
//RET: 0=I
int CSharpAt::CtSrcPassEx(char c1,char c2)
{
	int cnt=0;
	while (pos < fsize)
	{
		char wk = src[pos++];
		if( wk == c1 )
		{
			if( cnt<=0 )
				return 1;	// NEXT
			cnt --;
		}else if( wk == c2 )
			cnt ++;
	}
	return 0;	// I
}

// ɁAϐp̐i0`999jΎ擾A0ݒ
//RET: i񂾐
int CSharpAt::GetMemNum(char *s,int &n)
{
	int ret=0;
	n = 0;
	if ((*s >= '0') && (*s <= '9'))
	{
		// 񂩂l擾
		ret = GetNumStr(s,n);
		// ϐԍ͈̔͊OH
		if ((n<0) || (n>999))
		{
			MES_PUT("Error: Mem number [ %d ]", n);
			n = 0;	// 0ɂđ
		}
	}
	return ret;
}

// ϐǂׁAϐȂϐԍƂ̒g擾
//IN&OUT : ϐԍ擾p, ϐ̒l擾p
//RET: 0ȊOȂ擾
int CSharpAt::GetMem(int &pn,int &n)
{
	pn = n = 0;	// INIT
	char c = src[pos];
	// ϐia`zjȊOH
	if( ! ((c>='a') && (c<='z')) )
		return 0;	// ϐȊO
	pos ++;
	// ϐzH
	char c2 = src[pos];
	int num = 0;
	if( c2=='(' )
	{
		pos ++;
		c2 = src[pos];
		if (!((c2 >= 'a') && (c2 <= 'z')))
		{
			ERR_PUT(pos - 1);
			return 0;
		}
		pos ++;
		int wk = GetMemNum(&src[pos],num);
		pos += wk;
		num = mem[(int)(c2 - 'a')*SAT_MEM1_MAX + num];
	}else
	{
		//----------------------------------
		// H
		if ((c2 >= '0') && (c2 <= '9'))
		{
			// ̐l擾ilłȂꍇ́A0Ԃj
			GetNum(num);
			// ϐԍ͈̔͊OH
			if( (num<0) || (num>999) )
			{
				MES_PUT("Error: Mem number [ %d ]", num);
				ERR_PUT(pos - 1);
				return 0;
			}
		}
	}
	// lݒ
	pn = (int)(c-'a')*SAT_MEM1_MAX + num;
	n = mem[pn];
	return 1;	// ϐ
}

// ̐l擾ilłȂꍇ́A0Ԃj
int CSharpAt::GetNum(int &n)
{
	int ret = GetNumStr(&src[pos], n);
	pos += ret;
	return ret;
}
// 񂩂Al擾ilȂꍇ́A0Ԃj
//RET: i񂾐 
int CSharpAt::GetNumStr(char *s, int &n)
{
	int i=0;
	n = 0;
	// sscanfg킸ɍ擾
	char c = s[i];
	// }CiXȊOH
	if (c != '-')
	{
		// ȊOH
		if (!((c >= '0') && (c <= '9')))
			return 0;
	}
	// 擾
	char buf[16] = { c,0 };
	for (i = 1; i<11; i++)
	{
		c = s[i];
		if (!((c >= '0') && (c <= '9')))
			break;
		buf[i] = c;
	}
	buf[i] = 0;
	// l֕ϊ
	n = atoi(buf);
	return i;
}

// |C^ȂʒuƂ̒g̒l擾i|C^łȂ0Ԃj
//OUT: pn=|C^ʒu擾An=g̒l擾
int CSharpAt::GetPtNum(int &pn,int &n)
{
	pn = at;
	n = 0;
	if( src[pos] != '@' )
		return 0;	// |C^ȊO
	// (H
	pos++;
	if( src[pos]=='(' )
	{
		pos++;
		// l擾
		int n2;
		// ̐l擾ilłȂꍇ́A0Ԃj
		if (GetNum(n2)==0)
		{
			// ϐǂׁAϐȂϐԍƂ̒g擾
			int pn2;
			if (GetMem(pn2, n2)==0)
			{
				ERR_PUT(pos - 2);
				return 0;
			}
		}
		// @|C^̈ʒusH
		pn = n2 + at;
		if ((pn<0) || (pn >= SAT_DEF_MEM_MAX))
		{
			ERR_PUT(pos - 2);
			return 0;
		}
	}
	// @|C^̒g擾
	n = mem[pn];
	return 1;
}

// ϐ|C^ȂA̒lnɐݒBȊOȂ0Ԃ
//RET: 0ȊOȂ擾
int CSharpAt::GetNumEx(int &n)
{
	int pn;
	// |C^Ȃ炻̒g̒l擾i|C^łȂ0Ԃj
	if( GetPtNum(pn,n) )
		return 1;
	// ̐l擾ilłȂꍇ́A0Ԃj
	if( GetNum(n) )
		return 1;
	// ϐǂׁAϐȂϐԍƂ̒g擾
	if( GetMem(pn, n) )
		return 1;
	return 0;
}

// w̕񂩂AGetNumEx s
//RET: 擾i0=G[j
int CSharpAt::GetNumExStr(char *str, int &n)
{
	int len = strlen(str);
	if( len==0 ) return 0;
	// NX̒lێ
	DWORD	bk_pos = pos;
	DWORD	bk_fsize = fsize;
	char	*bk_src = src;
	// Vlݒ
	pos = 0;
	fsize = len;
	src = str;
	// s
	int ret = GetNumEx(n);
	if( ret )
		ret = pos;
	// NX̒l߂
	pos = bk_pos;
	fsize = bk_fsize;
	src = bk_src;
	return ret;
}

// J}؂̐liϐ|C^OKjw萔擾
//IN : 擾镶, 擾int^z, 擾, 擾ʒu擾i0Ȃ擾Ȃj
//RET: 擾i0=sj
int CSharpAt::GetCommaNum(char *str, int *p_n, int num, char **s_end)
{
	int cnt=0;	// 擾
	int len = strlen(str);
	if (len == 0) return 0;
	// NX̒lێ
	DWORD	bk_pos = pos;
	DWORD	bk_fsize = fsize;
	char	*bk_src = src;
	// Vlݒ
	pos = 0;
	fsize = len;
	src = str;

	// 擾
	for(int i=0; i<num; i++)
	{
		if( GetNumEx(p_n[cnt])==0 )	// sH
			break;
		cnt++;
		if( src[pos]!=',' )
			break;
		pos ++;
	}
	if( s_end )
		*s_end = &src[pos];
	// NX̒l߂
	pos = bk_pos;
	fsize = bk_fsize;
	src = bk_src;

	return cnt;
}

// w蕶܂Ŏ擾iSAT_STR_MAX܂Ŏ擾\j
//RET: 擾
int CSharpAt::GetStr(char *str, char chk_c)
{
	int n = GetStrEx(str, &src[pos], chk_c);
	pos += n;
	return n;
}

// w蕶܂Ŏ擾iSAT_STR_MAX܂Ŏ擾\j
//IN : i[obt@AoA`FbN镶
//RET: 擾
int CSharpAt::GetStrEx(char *buf, char *moto, char chk_c)
{
	int n = 0;
	while (moto[n])
	{
		if (n >= (SAT_STR_MAX - 1))
			break;
		char c = moto[n];
		// SpH
		if (IsZenkaku(c))
		{
			*buf++ = moto[n++];
			*buf++ = moto[n++];
			continue;
		}
		// IH
		if (c == chk_c)
		{
			n++;
			break;
		}
		// p
		*buf++ = c;
		n++;
	}
	*buf = 0;	// NULL
	return n;
}

// g@\ȂAg֐si0ȊOȂg@\sj
//OUT: retɊg֐̖߂l
int CSharpAt::PrEx(int &ret)
{
	ret = 0;
	char c = src[pos];
	if (! ((c >= 'A') && (c <= 'Z')) )// && (src[pos + 1] == '(')) )
		return 0;	// g
	pos ++;
	// w蕶܂Ŏ擾
	GetStr(str_buf, ';');
	// g֐sA߂lϐɐݒ
	ret = p_ExProc[(BYTE)c - (BYTE)'A'](this, str_buf);
	return 1;	// g֐s
}

//---------------------------------------
// #@̃C[v̏FAIΐ퓙ŁA1^[s鎞ɂg
//RET: 0ȂI
int CSharpAt::PrSharpAtMain()
{
	//-------------------------------------------------
	// RgspX
	if (CtNextSrc() == 0) return 0;
	//-------------------------------------------------
	// g@\H
	int ret;
	if (PrEx(ret))
		return 1;
	//-------------------------------------------------
	int pn, n;	// ϐԍ, ϐ̒g
	char c = src[pos];
	// ֐nH
	if (c == '#')
	{
		pos++;
		// ֐ԍ擾
		if (GetNumEx(n) == 0)
		{
			ERR_PUT(pos - 1);
			return 0;
		}
		// ֐͈̔͊OH
		if ((n<0) || (n >= SAT_PROC_MAX))
		{
			ERR_PUT(pos - 1);
			return 0;
		}
		// ֐̐錾H
		c = src[pos];
		if (c == '{')
		{
			pos++;
			// ֐ʒuێ
			proc[n] = pos;
			// ֐̏I܂ŃpX
			CtSrcPass('}');
		}
		else
		{	// ֐s
			// ݂̈ʒuێ
			CtPush(pos);
			// ֐փWv
			pos = proc[n];
		}
		return 1;
	}
	// ֐߂H
	if (c == '}')
	{
		pos = CtPop();
		return 1;
	}
	// ֐returnH
	if (c == '.')
	{
		pos++;
		// i݂Ȃ']'popA'['pushĂB'}'ŌĂяoO܂Ŗ߂
		while (pos < fsize)
		{
			if (src[pos] == '}')
			{
				pos = CtPop();
				break;
			}
			if (src[pos] == ']')
				CtPop();	// pop݂̂Œl͎̂Ă
			else if (src[pos] == '[')
				CtPush(pos);
			pos++;
		}
		return 1;
	}
	//-------------------------------------------------
	// ߂ʒuێ
	if (c == '[')
	{
		pos++;
		CtPush(pos);
		return 1;
	}
	// ̏IH
	if (c == ']')
	{
		CtPop();	// pop̂Ă
		pos++;
		// ̕'['ȂelseȂ̂ŁAΉ']'܂ŃpX
		if (src[pos] == '[')
		{
			pos++;
			if (CtSrcPassEx(']', '[') == 0)	// [[]]̎ɂɓ삳
				return 0;	// END
		}
		return 1;
	}
	//-------------------------------------------------
	// ̃Iyh擾Aɉďs
	//-------------------------------------------------
	// @|C^H
	if (c == '@')
	{
		pos++;
		// |C^̈ʒuςH
		switch (src[pos])
		{
		case ':':	// |C^ɕϐ̃AhXݒ
			pos++;
			if (GetMem(pn, n))	// ϐH
			{
				at = pn;		// @pnԍ̕ϐɂ 
			}
			else
			{
				ERR_PUT(pos - 1);
				return 0;
			}
			break;
		case '>':	// |C^EɈړ
			pos++;
			if (GetNumEx(n))	// l擾łH
			{
				at += n;
			}
			else
			{
				ERR_PUT(pos - 1);
				return 0;
			}
			break;
		case '<':	// |C^Ɉړ
			pos++;
			if (GetNumEx(n))	// l擾łH
			{
				at -= n;
			}
			else
			{
				ERR_PUT(pos - 1);
				return 0;
			}
			break;
		case '(':	// |C^̈ʒuςȂEEE
			pos--;	// ߂
					// |C^̈ʒuƒg擾
			if (GetPtNum(pn, n) == 0)
				return 0;	// END
			goto _JMP_RT;
		default:
			// Zq╪𒲂ׂ
			pn = at;
			n = mem[pn];
			goto _JMP_RT;
		}
		// @|C^̈ʒusH
		if ((at<0) || (at >= SAT_DEF_MEM_MAX))
		{
			ERR_PUT(pos - 1);
			return 0;
		}
		return 1;
	}
	// ϐǂׁAϐȂϐԍƂ̒g擾
	if (GetMem(pn, n))
	{
	_JMP_RT:
		// ϐl擾
		// ZqH
		c = src[pos];
		switch (c)
		{
			//--------------------------------------------------------------
			// Zq
		case '=': case '+': case '-': case '*': case '/': case '%': case '<': case '>':
		{
			int n2 = 0;
			pos++;
			// ϐ|C^ȂA̒l擾
			if (GetNumEx(n2) == 0)
			{
				if (PrEx(n2) == 0)
				{
					ERR_PUT(pos - 1);
					return 0;
				}
			}
			// Zq
			switch (c)
			{
			case '=':	// 
				mem[pn] = n2;	break;
			case '+':	// Z
				mem[pn] += n2;	break;
			case '-':	// Z
				mem[pn] -= n2;	break;
			case '*':	// |Z
				mem[pn] *= n2;	break;
			case '/':	// Z
				if (n2 == 0) break;
				mem[pn] /= n2;	break;
			case '%':	// ]
				if (n2 == 0) break;
				mem[pn] = mem[pn] % n2;	break;
			case '<':	// r
				mem[pn] = (mem[pn] < n2); break;
			case '>':	// r
				mem[pn] = (mem[pn] > n2); break;
			}
			break;
		}
		//--------------------------------------------------------------
		// 擪iifj
		case '[':
			// l0ȊOȂÂ܂ܐi݁A0Ȃ']'܂Ői
			if (n)
			{
				pos++;
				// ̈ʒuX^bN
				CtPush(pos);
			}
			else
			{
				// w̎̕܂ŃpX
				pos++;
				if (CtSrcPassEx(']', '[') == 0)	// [[]]̎ɂɓ삳
					return 0;	// END
			}
			break;
			// iforj
		case ']':
			// l0ȂÂ܂ܐi݁A0ȊOȂ'['̎܂Ŗ߂
			if (n == 0)
			{
				CtPop();	// pop̂Ă
				pos++;
				// ̕'['ȂelseȂ̂ŁAΉ']'܂ŃpX
				if (src[pos] == '[')
				{
					pos++;
					if (CtSrcPassEx(']', '[') == 0)	// [[]]̎ɂɓ삳
						return 0;	// END
				}
			}
			else
			{
				pos = CtPop();	// ߂ʒuݒ
				st_pos++;	// xX^bN̂
			}
			break;
		}
	}
	else
	{
		ERR_PUT(pos - 1);
		return 0;
	}
	return 1;
}

//---------------------------------------
// #@̃C[v
//RET: -1=ERR
int CSharpAt::GoSharpAt()
{
	int cnt=0;
	// t@C̏I܂Ń[v
	while( (pos<fsize) && (pos>=0) && (err==0) )
	{
		// #@C[vP񕪎s
		if( PrSharpAtMain()==0 )
			break;
		// SYSTEM֕Ԃ
		cnt ++;
		if( cnt>100 )
		{
			cnt = 0;
			ERET( SysTask() );
		}
	}
	// ĂяoIH
	if( err==-1 ) return -1;
	return 0;
}


//=======================================
// DATA
//=======================================
CSharpAt *sat;			// #@NX

#ifdef _DXLIB
// bZ[W{bNX
int MesBox(int no,char* s,char* title)
{
	// }EX\
//	SetMouseDispFlag(true);
	MessageBox(GetMainWindowHandle(),s,title,MB_OK);
//	SetMouseDispFlag(false);
	return 0;
}
//=======================================
// WinMainĂ΂֐F#@Jn
//=======================================
int StartSharpAt(char *p_fName)
{
	ClearDrawScreen();
	//---------------------------------------
	// st@C\
	if( p_fName[0]==0 )
		p_fName = sat_def_fname;
#ifndef _DXLIB
	MesBox(0, p_fName, "Eexecute a #@ program");
#endif
	//---------------------------------------
	// NX𐶐
	sat = new CSharpAt;
	// #@̃t@Cǂݍ
	ERET( sat->LoadSrcFile(p_fName) );
	//---------------------------------------
	// #@̃C[v
	ERET( sat->GoSharpAt() );

	//---------------------------------------
	// Sĉ
	delete sat;
	return 0;
}
#else
//=======================================
// Q[Ă΂֐F#@Jn
//=======================================
int GM::StartSharpAt(int)
{
#ifndef _DEBUG
//	int sz=sizeof(CSharpAt);	// NX̃TCY𒲂ׂ鎞p
	// ŏ
	static char flg=0;
	if( flg==0 )
//	if( GC::sv.pd.ev_flg.is_sharpat_help==0 )
	{
		flg = 1;
	//	GC::sv.pd.ev_flg.is_sharpat_help = 1;
		SE::Play(SE_STORY2);
		ERET( Eff::FadeOut(vram) );
		SE::Play(SE_EYE);
		ERET(PrMesWindDef(vram,str_sharpat_help));
	}
	SE::Play(SE_STORY2);
	ERET(Eff::FadeOut(vram));
#else
	ViewCls();
	ERET( PaintMain(1) );
#endif
	//---------------------------------------
	// st@C\
	char *p_fName = cmdLine;
	if( (p_fName[0]==0) || (cmdLine==0) )
		p_fName = SetPath(sat_def_fname);
	MesBox(0, p_fName, "Eexecute a #@ program");

	//---------------------------------------
	// NX𐶐
	sat = new CSharpAt;
	// #@̃t@Cǂݍ
	ERET( sat->LoadSrcFile(p_fName) );
	//---------------------------------------
	// t[[gݒ
	WORD bk_tb_wait = tb_wait;
	tb_wait = (1000/60);	//1t[WAIT: 50=20fps
	// #@̃C[v
	ERET( sat->GoSharpAt() );
	tb_wait = bk_tb_wait;	// ߂

	//---------------------------------------
	// Sĉ
	delete sat;
	return 0;
}
#endif

//=======================================
// p֐
//=======================================
// Ή̕\p
void CSharpAt::NON_CODE_PUT(int _pos)
{
	if (_pos<0) _pos = 0;
	char buf[32];
	memcpy(buf, &src[_pos], 16);
	buf[16] = 0;
	MES_PUT("Non code (pos=%d): %s", _pos, buf);
	err = 1;	// 1=ʏG[
}
// G[\pFG[̉ӏ琔̃vO\
//IN : G[ʒu
void CSharpAt::ERR_PUT(int _pos)
{
	if( _pos<0 ) _pos = 0;
	char buf[32];
	memcpy(buf, &src[_pos], 16);
	buf[16] = 0;
	MES_PUT("Error(pos=%d): %s", _pos, buf);
	err = 1;	// 1=ʏG[
}
// bZ[W\pFɃfobOG[p
void CSharpAt::MES_PUT(char *mes, ...)
{
	char str[1024];
	va_list list;
	va_start(list, mes);
	vsprintf(str, mes, list);
	va_end(list);
	MesBox(0,str,"#@ Language");
	InitKeyFlag();
}
// 1oCgڂSpȂ1Ԃ
int CSharpAt::IsZenkaku(char c)
{
	BYTE b = (BYTE)c;
	if (b < 33)
	{
		if ((b == 10) || (b == 13) || (b == 9))	// sTabHieLXgt@Cpj
			return 0;	// p
		return 1;		// Sp
	}
	if (b <= 126) return 0;		// ALF
	if (b < 161) return 1;		// Sp
	if (b <= 223) return 0;		// ALF
	return 1;	// Sp
}
